'''
Advanced Power OS Version Module
2009(c) Kirill Plyashkevich <ru.spirit@gmail.com>
'''

import os.path
from modules.AbstractModules import AbstractModuleWithFileSource

class OSVersion(AbstractModuleWithFileSource):

  def pre_init(self):
    self.interval = -1
    self.value = 'Unknown'
    for vfile in ('/etc/osso_software_version', '/etc/lsb-release'):
      if os.path.exists(vfile) and os.path.isfile(vfile):
        self.file = vfile
        break

  def process(self, lines):
    version = ''
    if self.file == '/etc/osso_software_version':
      version = lines[0].rsplit('_')[2]
    elif self.file == '/etc/lsb-release':
      version = ('%s %s' % (lines[0].rsplit('=')[1], lines[1].rsplit('=')[1])).strip('\"')
    return version
