'''
Advanced Power Bluetooth Wrapper BlueZ
2009(c) Kirill Plyashkevich <ru.spirit@gmail.com>
'''

from wrappers.bluetooth.AbstractBluetooth import AbstractBluetooth

class BluetoothBlueZ(AbstractBluetooth):

  def pre_init(self):
    self.friendly_name = 'BlueZ'
    self.dep_packages = ['bluez-utils']
    self.interfaces_map = {'BlueZ': ('org.bluez', '/org/bluez/hci0', 'org.bluez.Adapter')}
    self.export_signals = {'bluetooth_mode': {'path': '/org/bluez/hci0', 'dbus_interface': 'org.bluez.Adapter', 'signal_name': 'ModeChanged'}}

  def get_status(self):
    try:
      self.mode = str(self.interfaces['BlueZ'].GetMode())
    except:
      pass
    try:
      available_modes = self.interfaces['BlueZ'].ListAvailableModes()
      self.available_modes = [str(x) for x  in available_modes]
      del available_modes
    except:
      pass

  def mode_handler(self, signal):
    signal = str(signal)
    if signal in self.get_available_modes():
      self.mode = signal

  def get_mode(self):
    return self.mode

  def set_mode(self, mode):
    try:
      self.interfaces['BlueZ'].SetMode(mode)
      self.mode = str(self.interfaces['BlueZ'].GetMode())
    except:
      pass

  def get_available_modes(self):
    return self.available_modes
