'''
Advanced Power Device Mode Wraper MCE
2009(c) Kirill Plyashkevich <ru.spirit@gmail.com>
'''

from wrappers.usb_mode.AbstractUSBMode import AbstractUSBMode
from Util import Shell

class USBModeHAL(AbstractUSBMode):

  def pre_init(self):
    self.friendly_name = 'HAL USB'
    self.dep_packages = ['hal']
    self.interfaces_map = {'USB-HAL': ('org.freedesktop.Hal', '/org/freedesktop/Hal/devices/usb_device_0_0_musb_hdrc', 'org.freedesktop.Hal.Device')}
    self.export_signals = {'usb_mode': {'path': '/org/freedesktop/Hal/devices/usb_device_0_0_musb_hdrc', 'dbus_interface': 'org.freedesktop.Hal.Device', 'signal_name': 'PropertyModified'}}

  def get_status(self):
    self.mode_handler('usb_device', [['usb_device.mode']])
    self.usb_modes = ['otg', 'host']

  def mode_handler(self, value, props):
    signals = [str(x[0]) for x in props]
    if 'usb_device.mode' in signals:
      try:
        mode = str(self.interfaces['USB-HAL'].GetPropertyString(u'usb_device.mode'))
      except:
        mode = 'unknown'
      if mode == 'b_idle' or mode == 'b_peripheral':
        self.usb_mode = 'otg'
      elif mode == 'a_wait_bcon':
        self.usb_mode = 'host'
      else:
        self.usb_mode = mode

  def get_mode(self):
    return self.usb_mode

  def set_mode(self, mode):
    Shell.run_command('echo %s > /sys/devices/platform/musb_hdrc/mode' % mode)
    self.mode_handler('usb_device', [['usb_device.mode']])

  def get_available_modes(self):
    return self.usb_modes